#include "playsong.h"
#include <sys/soundcard.h>
#include <iostream>
#include <stdlib.h>
#include <time.h>
#include "chordscale.h"


// all this should be in a config-file, which i could call.... hmm... style..
#define rideOnBeat 0.8f     // even eigth
#define rideOffBeat 0.4f    // offbeat eigth
#define rideOnBeatVelocity 100
#define rideOffBeatVelocity 50
#define hihatOnStrong 0.9f  // means measure 2 and 4
#define hihatOnWeak 0.1f    // means measure 1 and 3
#define hihatVelocity
#define lowestBassNote 32
#define highestBassNote 45
#define startBassNote 36
#define changeRunsOnOne 0.3f
#define primeOnOne 0.5f

#define lowChordTone1 55
#define hiChordTone1 61
#define lowChordTone2 58
#define hiChordTone2 64
#define lowChordTone3 61
#define hiChordTone3 65
#define lowChordTone4 65
#define hiChordTone4 69
#define rangePerVoice 5
#define lowestChordTone 55
#define highestChordTone 77

#define velocityMod 10

void FindNextChord(int *currentChord, ChordScale *currentChordScale, bool *run);
void StopChord(int *chord);
void PlayChord(int *chord);
	
int playSong(Song *mySong)
	{
	
	SEQ_MIDIOUT(midiDevice, 0xc0);
	SEQ_MIDIOUT(midiDevice, 0);
	SEQ_MIDIOUT(midiDevice, 0);
	SEQ_MIDIOUT(midiDevice, 35);
	SEQ_DUMPBUF();                           	

	SEQ_MIDIOUT(midiDevice, 0xc1);
	SEQ_MIDIOUT(midiDevice, 0);
	SEQ_MIDIOUT(midiDevice, 0);
	SEQ_MIDIOUT(midiDevice, 4);
	SEQ_DUMPBUF();                           	

	
	SEQ_START_TIMER();

	// first calculate the delays. we need two for the eigth, since we are swinging.. hehe
	// but first we need for ease of calculus the fourth..
	int quarterTime = (int)((60.0 / mySong->getBPM() ) * rate);
	int eigthTime = (int) (quarterTime * mySong->getShuffle());


	// we need to keep track..
	int currentTick = 0;
	
	std::cout << "ticks for a quarter note: " << quarterTime << std::endl;
	std::cout << "ticks for an eigth note: " << eigthTime << std::endl;

	time_t myTime = time(&myTime);
	srand(myTime); // this should be changed...


	int bassNote = startBassNote;
	bool bassNoteOn = false;
	bool run = true; // true means up, false means down;
	int chord[4]; // a chord is made up from the weights of the chordscale..
	bool ChordOn = false;
	bool ChordRun = true;
//	int velocityMod = 0;

	for (int currentLoop = 0; currentLoop < mySong->getLoops(); currentLoop++)
		{
		int measureInBeat = 0;
		ChordScale *currentChordScale;
		int currentKey;

    for (int currentMeasure = 0; currentMeasure < mySong->getLength(); currentMeasure++)
			{
			SEQ_WAIT_TIME( currentTick-1);
			// if Bass is still played from previoues measure, we need to stop it
			if (bassNoteOn)
				{
	    	SEQ_MIDIOUT(midiDevice, 0x90);
 		   	SEQ_MIDIOUT(midiDevice, bassNote);
 	 	  	SEQ_MIDIOUT(midiDevice, 0);
 	 	  	SEQ_MIDIOUT(midiDevice, 0);
				}
	
			currentTick = ((currentLoop*mySong->getLength()) + currentMeasure) * quarterTime;

			// lets see. new chord? or even chordscale?
			if (mySong->getChordScale(currentMeasure)->getIsUsed())
				{
				currentChordScale = mySong->getChordScale(currentMeasure);
				currentKey=currentChordScale->getKey();


				if (ChordOn)
					StopChord(chord);

				
				if ((rand() / (float)RAND_MAX) < changeRunsOnOne)
					{
					ChordRun = !ChordRun;
					}
				FindNextChord(chord, currentChordScale,&ChordRun);

	  		SEQ_WAIT_TIME( currentTick);
        PlayChord(chord);
				ChordOn = true;
				}
  		SEQ_WAIT_TIME( currentTick);
//			std::cout << currentChordScale->getKey() << std::endl;


			measureInBeat = currentMeasure % 4;
//			std::cout << mySong->getChordScale(currentMeasure)->getChordName() << std::endl;
				
			// now, we definetly need to play a bassnote
			// so lets check, if we need to change direction of run
      if ( 			
							(((rand() / (float)RAND_MAX) < changeRunsOnOne) && (measureInBeat == 0))
					)
				{
				run = !run;
				}

			if (bassNote >  highestBassNote)
      	run = false;
			if (bassNote <  lowestBassNote)
      	run = true;
				
			

		 	// ok. now find the next bassnote. check the chordscale to find one.
 	 		for (int i = 0; (i < 12) && (i > -12); )
				{
				if (run) // depending on the variable 'run' we search up, or down..
					i += 1;
				else
					i -= 1;
	
      	if ( currentChordScale->getWeight((i + bassNote - currentKey) % 12))
					{
					bassNote += i;
					break;
					}
				}

			
	   	SEQ_MIDIOUT(midiDevice, 0x90);
 	   	SEQ_MIDIOUT(midiDevice, bassNote);
 	  	SEQ_MIDIOUT(midiDevice, 100 + 0);
 	  	SEQ_MIDIOUT(midiDevice, 0);
			bassNoteOn = true;
			
		

      // noteOn  onBeat


			// ok, first, we do the drums

			if ((measureInBeat == 1) || (measureInBeat == 3))
				{
	    	SEQ_MIDIOUT(midiDevice, 0x99);
 		   	SEQ_MIDIOUT(midiDevice, 42);
 	 	  	SEQ_MIDIOUT(midiDevice, rideOnBeatVelocity);
 	 	  	SEQ_MIDIOUT(midiDevice, 0);

				SEQ_WAIT_TIME (currentTick + 1);
	    	SEQ_MIDIOUT(midiDevice, 0x99);
 		   	SEQ_MIDIOUT(midiDevice, 42);
 	 	  	SEQ_MIDIOUT(midiDevice, 0);
 	 	  	SEQ_MIDIOUT(midiDevice, 0);
    		}
			
    	SEQ_MIDIOUT(midiDevice, 0x99);
    	SEQ_MIDIOUT(midiDevice, 51);
    	SEQ_MIDIOUT(midiDevice, rideOnBeatVelocity);
    	SEQ_MIDIOUT(midiDevice, 0);
			

      // noteOff RIDE
			SEQ_WAIT_TIME( currentTick + eigthTime - 1);

    	SEQ_MIDIOUT(midiDevice, 0x99);
    	SEQ_MIDIOUT(midiDevice, 51);
    	SEQ_MIDIOUT(midiDevice, 0);
    	SEQ_MIDIOUT(midiDevice, 0);


			// noteOn offBeat RIDE
			SEQ_WAIT_TIME( currentTick + eigthTime);

			if ((rand() / (float)RAND_MAX) < rideOffBeat)
				{
	    	SEQ_MIDIOUT(midiDevice, 0x99);
 	  	 	SEQ_MIDIOUT(midiDevice, 51);
  	 	 	SEQ_MIDIOUT(midiDevice, rideOffBeatVelocity);
    		SEQ_MIDIOUT(midiDevice, 0);
				}
			

      // noteOff RIDE
			SEQ_WAIT_TIME( currentTick + quarterTime -1 );

    	SEQ_MIDIOUT(midiDevice, 0x99);
    	SEQ_MIDIOUT(midiDevice, 51);
    	SEQ_MIDIOUT(midiDevice, 0);
    	SEQ_MIDIOUT(midiDevice, 0);
			
			SEQ_DUMPBUF();
			
			}
		SEQ_DUMPBUF();
		}


	return 0;
	}



void PlayChord(int *chord)
	{
	for (int i = 0; i < 4; i++)
		{
 		SEQ_MIDIOUT(midiDevice, 0x91);
 		SEQ_MIDIOUT(midiDevice, chord[i]);
 		SEQ_MIDIOUT(midiDevice, 70);
 		SEQ_MIDIOUT(midiDevice, 0);
		}


	}

void StopChord(int *chord)
	{
	for (int i = 0; i < 4; i++)
		{
 		SEQ_MIDIOUT(midiDevice, 0x91);
 		SEQ_MIDIOUT(midiDevice, chord[i]);
 		SEQ_MIDIOUT(midiDevice, 0);
 		SEQ_MIDIOUT(midiDevice, 0);
		}
	}


int chordoffset = 0;
void FindNextChord(int *currentChord, ChordScale *currentChordScale, bool *run)
	{


	if (lowChordTone1 + chordoffset < lowestChordTone)
		{
		*run = true;
		}

	if (hiChordTone4 + chordoffset > highestChordTone)
		{
		*run = false;
		}


	if (*run)
		{
		chordoffset += 1;
		}
	else
		{
		chordoffset -= 1;
		}

	
	bool cont = true;
	for (int i = lowChordTone1 + chordoffset; (i < hiChordTone1 + chordoffset) && cont; i++)
		{
    if (currentChordScale->getWeight ((i - currentChordScale->getKey()) % 12))
			{
			currentChord[0] = i;
			cont = false;
			}
		}

	cont = true;
	for (int i = lowChordTone2+ chordoffset; (i < hiChordTone2+ chordoffset) && cont; i++)
		{
    if (currentChordScale->getWeight ((i - currentChordScale->getKey()) % 12))
			{
			currentChord[1] = i;
			cont = false;

			}
		}

	cont = true;
	for (int i = lowChordTone3+ chordoffset; (i < hiChordTone3+ chordoffset) && cont; i++)
		{
    if (currentChordScale->getWeight ((i - currentChordScale->getKey()) % 12))
			{
			currentChord[2] = i;
			cont = false;

			}
		}

	cont = true;
	for (int i = lowChordTone4+ chordoffset; (i < hiChordTone4+ chordoffset) && cont; i++)
		{
    if (currentChordScale->getWeight ((i - currentChordScale->getKey()) % 12))
			{
			currentChord[3] = i;
			cont = false;

			}
		}

	}                                                                      	