#include "song.h"
#include <iostream>
Song::Song()
	{
	myChordScales = new ChordScale[1000];
	Key = 0;
	Length = 32;
	Shuffle = 0.5;
	BPM = 120;
	Loops = 1;
	}
	

Song::Song(int newKey, int length, char* name)
	{
	myChordScales = new ChordScale[1000];
	Key = newKey;
	Length = length;
	strcpy(Name, name);
	BPM = 120;
	Shuffle = 0.5;
	Loops = 1;
	}

ChordScale *Song::getChordScale(int measure)
	{
	return &(myChordScales[measure]);
	}

Song::~Song()
	{
	delete[] myChordScales;
	}

int Song::LoadSong(char *fileName)
	{
	//open file
	char LineBuffer[300];
	char LineBuffer2[300];	
	FILE *myFile;
	if ((myFile = fopen(fileName, "r")) == NULL)
		{
		return 1;
		}

	// read SongName from File
	if( fgets(LineBuffer, 200, myFile) == NULL)
		{
		return 2;
		}
	
        for (unsigned int i = 0; i < (strlen(LineBuffer) - 1); ++i)
		{
		Name[i] = LineBuffer[i];
		}
	Name[strlen(LineBuffer) - 1] = '\0';

//	std::cout << Name <<std::endl;
	// finished with song name..



	// read empty line
	if( fgets(LineBuffer, 200, myFile) == NULL)
		{
		return 3;
		}	



	// read tempo
	if( fgets(LineBuffer, 200, myFile) == NULL)
		{
		return 15;
		}	
	BPM = atoi(LineBuffer);

	// read shuffle
	if( fgets(LineBuffer, 200, myFile) == NULL)
		{
		return 66;
		}	
	Shuffle = atof(LineBuffer);


	// read number of measures in song
	if( fgets(LineBuffer, 200, myFile) == NULL)
		{
		return 4;
		}
	
	Length = atoi(LineBuffer);
	// done reading length

	// read number of Loopa in song
	if( fgets(LineBuffer, 200, myFile) == NULL)
		{
		return 4;
		}
	
	Loops = atoi(LineBuffer);
	// done reading Loops
	

	// read all the chords/scales	
	// .. first pass of loop reads initial values (measure 0, the song starts at 1)
	
//	std::cout << Loops <<std::endl;
	for (int i = 0; i < Length ; ++i) 
		{
		// read empty line
		if( fgets(LineBuffer, 200, myFile) == NULL)
			{
			return 5;
			}
		
//		std::cout << LineBuffer;

		
		//checken, ob "rep"
		if (strncmp(LineBuffer, "rep", 3) == 0)
			{
			myChordScales[i].setIsUsed(false)	;
			}
		else
			{
			if (strncmp (LineBuffer, "\n",1) != 0)
				return 15;

			myChordScales[i].setIsUsed(true);
			// read key of chord
			if( fgets(LineBuffer, 200, myFile) == NULL)
				{
				return 1;
				}	
			myChordScales[i].setKey(atoi(LineBuffer));
		




			// read flag for chord/chordscale
			if( fgets(LineBuffer, 200, myFile) == NULL)
				{
				return 6;
				}	
			
			if (strncmp(LineBuffer, "cs", 2) == 00)
				{
				myChordScales[i].setIsScale(true);
				}
			else
				{
				myChordScales[i].setIsScale(false);
				}
			// done with the scale flag..
	
	



			//now we set the key of the scale.
			if (myChordScales[i].getIsScale())
				{
				if( fgets(LineBuffer, 200, myFile) == NULL)
					{
					return 7;
					}	
				myChordScales[i].setScaleKey(atoi(LineBuffer));
				}
			

		



			// now on to the chord notes (the weights)
			if( fgets(LineBuffer, 200, myFile) == NULL)
				{
				return 8;
				}
//			std::cout << LineBuffer << std::endl;
			for (int j = 0; j < (strlen(LineBuffer) - 1); ++j)
				{
				if (LineBuffer[j] == 'x')
					{
					myChordScales[i].setWeight(j, true);
					}	
				else
					{
					myChordScales[i].setWeight(j, false);
					}
				}	
	
			// done with chord tones
				
	



			// this one's for the scales
			if (myChordScales[i].getIsScale())
				{
				if( fgets(LineBuffer, 200, myFile) == NULL)
					{
					return 9;
					}

				for (int j = 0; j < (strlen(LineBuffer) - 1); ++j)
					{
					if (LineBuffer[j] == 'x')
						{
						myChordScales[i].setNote(j, true);
						}		
					else
						{
						myChordScales[i].setNote(j, false);
						}
					}	
	
				}
			// done with the scales here..	
		
	



			// last thing: name of the chord
			if( fgets(LineBuffer, 200, myFile) == NULL)
				{
				return 10;
				}

      for (unsigned int k = 0; k < (strlen(LineBuffer) - 1); ++k)
				{
				LineBuffer2[k] = LineBuffer[k];
				}


      LineBuffer2[strlen(LineBuffer) - 1] = '\0';


			myChordScales[i].setChordName(LineBuffer2);
			// done with the name
	

			}
		}
	
	// done reading chords hehe so close the file
	fclose(myFile);
	return 0;
	}

void Song::setName(char *name)
	{
	strcpy(Name,name);
	}

char *Song::getName()
	{
	return Name;
	}

void Song::setLength(int length)
	{
	Length = length;
	}

int Song::getLength()
	{
	return Length;
	}


void Song::setLoops(int loops)
	{
	Loops = loops;
	}

int Song::getLoops()
	{
	return Loops;
	}

void Song::setStartLoop(int measure)
	{
	StartLoop = measure;
	}

int Song::getStartLoop()
	{
	return StartLoop;
	}

void Song::setEndLoop(int measure)
	{
	EndLoop = measure;
	}
	
int Song::getEndLoop()
	{
	return EndLoop;
	}

void Song::setKey(int key)
	{
	Key = key;
	}
	
int Song::getKey()
	{
	return Key;
	}

void Song::setBPM(int bpm)
	{
	BPM = bpm;
	}

int Song::getBPM()
	{
	return BPM;
	}	

void Song::setShuffle(float shuffle)
	{
	Shuffle = shuffle;
	}

float Song::getShuffle()
	{
	return Shuffle;
	}	