#ifndef MY__SONG
#define MY__SONG

#include "chordscale.h"
#include <vector>
#include <string.h>
#include <stdio.h>

// Key is defined with following values:
// 0 = C, 1 = C#, 3 = D, ...... ,12 = B (H)

// each measure is either a chord/chordscale, or just a chord; the weights in
// the chord are the chord - tones.. including extensions
// weight[14] is a b9 for example..

using namespace std;

class Song
	{
	ChordScale *myChordScales;
	int Key;
	int Length;
	int BPM;
	char Name[200];
	float Shuffle;
	int Loops;
	int StartLoop;
	int EndLoop;

	public:
		Song();	
		Song(int newKey, int length, char *name);
		~Song();

		ChordScale *getChordScale(int measure);
		void setChordScale(int bar, ChordScale* newChordScale);

		int LoadSong(char *fileName);

		void setName(char *name);
		char *getName();

		void setLength(int length);
		int getLength();

		void setLoops(int loops);
		int getLoops();
		void setStartLoop(int measure);
		int getStartLoop();
		void setEndLoop(int measure);
		int getEndLoop();

		void setKey(int key);
		int getKey();

		void setBPM(int bpm);
		int getBPM();
		
		void setShuffle(float shuffle);
		float getShuffle();

	};
	
#endif